<?php

namespace app\models\museumResult;

use Yii;
use yii\helpers\ArrayHelper;

/**
 * This is the model class for table "coefficients".
 *
 * @property integer $id
 * @property integer $museum_id
 * @property string $dateStart
 * @property string $dateFinish
 * @property double $value
 * @property integer $ballType
 *
 * @property Museum $museum
 */
class MuseumCoefficient extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'coefficients';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['museum_id'], 'integer'],
            [['dateStart', 'dateFinish'], 'safe'],
            [['value'], 'number'],
            [['dateStart', 'dateFinish', 'value'], 'required'],
            ['dateStart', 'compare', 'operator' => '<=', 'compareAttribute' => 'dateFinish'],
            ['dateFinish', 'compare', 'operator' => '>=', 'compareAttribute' => 'dateStart'],
            [['museum_id'], 'exist', 'skipOnError' => true, 'targetClass' => Museum::className(), 'targetAttribute' => ['museum_id' => 'id']],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'museum_id' => 'Музей',
            'dateStart' => 'С какой даты',
            'dateFinish' => 'По какую дату',
            'value' => 'Значение',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getMuseum()
    {
        return $this->hasOne(Museum::className(), ['id' => 'museum_id']);
    }

    public static function getValue($date, $museum_id)
    {
        $coefficientInfo = static::find()
            ->andWhere(['<=', 'dateStart', $date])
            ->andWhere(['>=', 'dateFinish', $date])
            ->andWhere(['museum_id' => $museum_id])
            ->orderBy(['value' => SORT_DESC])
            ->select('value')
            ->asArray()
            ->one();

        return floatval(ArrayHelper::getValue($coefficientInfo, 'value', 1.0));
    }

    public function afterDelte()
    {
        MuseumBall::recalculateByDate(
            $this->museum_id,
            $this->dateStart,
            $this->dateFinish
        );

        return parent::afterDelete(); // TODO: Change the autogenerated stub
    }

    /**
     * @param bool  $insert
     * @param array $changedAttributes
     */
    public function afterSave($insert, $changedAttributes)
    {
        if($insert) {
            MuseumBall::recalculateByDate(
                $this->museum_id,
                $this->dateStart,
                $this->dateFinish
            );
        }
        else {
            //Пересчет баллов с этим музеем для всех команд,
            //посетивших этот музей в тот период
            if (isset($changedAttributes['museum_id'])) {
                MuseumBall::recalculateByDate(
                    $changedAttributes['museum_id'],
                    min(
                        ArrayHelper::getValue(
                            $changedAttributes,
                            'dateStart',
                            $this->dateStart),
                        $this->dateStart),
                    max(
                        ArrayHelper::getValue(
                            $changedAttributes,
                            'dateFinish',
                            $this->dateFinish),
                        $this->dateFinish)
                );
                MuseumBall::recalculateByDate(
                    $this->museum_id,
                    min(
                        ArrayHelper::getValue(
                            $changedAttributes,
                            'dateStart',
                            $this->dateStart),
                        $this->dateStart),
                    max(
                        ArrayHelper::getValue(
                            $changedAttributes,
                            'dateFinish',
                            $this->dateFinish),
                        $this->dateFinish)
                );
            } elseif (isset($changedAttributes['value'])) {
                MuseumBall::recalculateByDate(
                    $this->museum_id,
                    min(
                        ArrayHelper::getValue(
                            $changedAttributes,
                            'dateStart',
                            $this->dateStart),
                        $this->dateStart),
                    max(
                        ArrayHelper::getValue(
                            $changedAttributes,
                            'dateFinish',
                            $this->dateFinish),
                        $this->dateFinish)
                );
            } else {
                if (isset($changedAttributes['dateStart'])) {
                    MuseumBall::recalculateByDate(
                        $this->museum_id,
                        min($changedAttributes['dateStart'], $this->dateStart),
                        max($changedAttributes['dateStart'], $this->dateStart)
                    );
                }

                if ($changedAttributes['dateFinish']) {
                    MuseumBall::recalculateByDate(
                        $this->museum_id,
                        min($changedAttributes['dateFinish'], $this->dateFinish),
                        max($changedAttributes['dateFinish'], $this->dateFinish)
                    );
                }
            }
        }

        return parent::afterSave($insert, $changedAttributes);
    }
}
